import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import {FormsModule} from '@angular/forms';

import { MaterialModule } from 'packages/commons/material/material.module';

import { COMPONENTS } from './component';
import { SERVICES } from './service';
import { SensorStoreModule } from './sensor-store.module';
import { SettingComponent } from './component/setting/setting.component';
import { TreeModule } from 'angular-tree-component';
import { PerfectScrollbarModule } from 'ngx-perfect-scrollbar';

@NgModule({
  imports: [
    CommonModule,
    MaterialModule,
    FormsModule,
    SensorStoreModule,
    TreeModule,
    PerfectScrollbarModule
  ],
  declarations: [
    COMPONENTS,
  ],
  exports: [
    COMPONENTS,
  ],
  providers: [
    SERVICES,
  ],
  entryComponents: [
    SettingComponent
  ]
})
export class SensorModule { }

